Unit asb2e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFB2E_p, UTAFSI_p;

procedure asb2e(var A :Array of Extended; MA :Integer;
                N :Integer; ML :Integer; MU :Integer;
                var NLEAD :Array of Integer; var B :Array of Extended;
                LTR :Integer; L :Integer; var RCOND :Extended;
                var Z :Array of Extended; var IERR :Integer);

implementation

procedure asb2e(var A :Array of Extended; MA :Integer;
                N :Integer; ML :Integer; MU :Integer;
                var NLEAD :Array of Integer; var B :Array of Extended;
                LTR :Integer; L :Integer; var RCOND :Extended;
                var Z :Array of Extended; var IERR :Integer);
var
I,I0,I1,J,J0,J1,JJ,K,KB,KP1,LM,M,NM1 :Integer;
S,T :Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410,_420,_430,
_440,_450,_460;
begin
{ ***************************************************C }
{   PEEHE CCTEM A*X=B  TRANS(A)*X=B METOOM   C }
{   AYCCA C BOPOM BEYEO EMEHA O CTOY    C }
{   OEHKA OYCOBEHHOCT EHTOHO MATP A.      C }
{ ***************************************************C }
RCOND  := 0.0e0;

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
S  := 0.0e0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N  >=  1 ) and (  MA  >=  1 ) 
 then goto _20;
IERR  := 65;
UTAFSI('A','S','B','2','E',IERR);
goto _460;
_20:
IERR  := 0;
NM1  := N - 1;
if ( L  <>  0 ) 
 then goto _30;
AFB2E(A,MA,N,ML,MU,NLEAD,RCOND,Z,IERR);
if ( IERR  <>  0 ) 
 then UTAFSI('A','S','B','2','E',IERR);
if ( IERR  <=  0 ) 
 then goto _30;
goto _460;
_30:
M  := ML + MU + 1;
for I:=1 to N do
 begin
  J0  := Max0(1,I-ML);
  J1  := Min0(N,I+ML+MU);
  for J:=J0 to J1 do
   begin
    K  := J - I + ML + 1;
    Z[J-1] := A[(I-1)+(K-1)*MA];
_40:
   end;
  for J:=J0 to J1 do
   begin
    A[(I-1)+(J-1)*MA] := Z[J-1];
_50:
   end;
_60:
 end;
for J:=1 to N do
 begin
  I0  := Max0(1,J-ML-MU);
  I1  := Min0(N,J+ML);
  for I:=I0 to I1 do
   begin
    K  := I - J + M;
    Z[K-1] := A[(I-1)+(J-1)*MA];
_70:
   end;
  for I:=I0 to I1 do
   begin
    K  := I - J + M;
    A[(K-1)+(J-1)*MA] := Z[K-1];
_80:
   end;
_90:
 end;
if ( LTR  <>  0 ) 
 then goto _250;

{   PEEHE CCTEM L*Y=B }
if ( ML  =  0 ) 
 then goto _160;
if ( NM1  <  1 ) 
 then goto _160;
for K:=1 to NM1 do
 begin
  LM  := Min0(ML,N-K);
  JJ  := NLEAD[K-1];
  T  := B[JJ-1];
  if ( JJ  =  K ) 
   then goto _100;
  B[JJ-1] := B[K-1];
  B[K-1] := T;
_100:
  I0  := M + 1;
  I1  := M + LM;
  I  := ((LM) Mod (4)) + M;
  if ( I  =  M ) 
   then goto _120;
  for JJ:=I0 to I do
   begin
    KP1  := JJ + K - M;
    B[KP1-1] := B[KP1-1] + T*A[(JJ-1)+(K-1)*MA];
_110:
   end;
_120:
  I  := I + 1;
  if ( I  >  I1 ) 
   then goto _140;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    KP1  := JJ + K - M;
    B[KP1-1] := B[KP1-1] + T*A[(JJ-1)+(K-1)*MA];
    B[KP1+0] := B[KP1+0] + T*A[(JJ+0)+(K-1)*MA];
    B[KP1+1] := B[KP1+1] + T*A[(JJ+1)+(K-1)*MA];
    B[KP1+2] := B[KP1+2] + T*A[(JJ+2)+(K-1)*MA];
_130:
    inc(JJ,4);
   end;
_140:
_150:
 end;
_160:

{   PEEHE CCTEM U*X=Y }
for KB:=1 to N do
 begin
  K  := N + 1 - KB;
  if ( A[(M-1)+(K-1)*MA] <>  0.0e0 ) 
   then goto _180;
  if ( B[K-1] <>  0.0e0 ) 
   then goto _170;
  B[K-1] := 1.0e0;
  goto _190;
_170:
  IERR  := 67;
  UTAFSI('A','S','B','2','E',IERR);
  goto _390;
_180:
  B[K-1] := B[K-1]/A[(M-1)+(K-1)*MA];
_190:
  T  := B[K-1];
  LM  := Min0(K,M) - 1;
  if ( LM  <  1 ) 
   then goto _230;
  I0  := M - LM;
  I1  := M - 1;
  I  := ((LM) Mod (4)) + I0 - 1;
  if ( I  <  I0 ) 
   then goto _210;
  for JJ:=I0 to I do
   begin
    KP1  := JJ + K - M;
    B[KP1-1] := B[KP1-1] - T*A[(JJ-1)+(K-1)*MA];
_200:
   end;
_210:
  I  := I + 1;
  if ( I  >  I1 ) 
   then goto _230;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    KP1  := JJ + K - M;
    B[KP1-1] := B[KP1-1] - T*A[(JJ-1)+(K-1)*MA];
    B[KP1+0] := B[KP1+0] - T*A[(JJ+0)+(K-1)*MA];
    B[KP1+1] := B[KP1+1] - T*A[(JJ+1)+(K-1)*MA];
    B[KP1+2] := B[KP1+2] - T*A[(JJ+2)+(K-1)*MA];
_220:
    inc(JJ,4);
   end;
_230:
_240:
 end;
goto _390;

{   PEEHE CCTEM TRANS(U)*Y=B }
_250:
for K:=1 to N do
 begin
  T  := 0.0e0;
  LM  := Min0(K,M) - 1;
  if ( LM  <  1 ) 
   then goto _290;
  I0  := M - LM;
  I1  := M - 1;
  I  := ((LM) Mod (5)) + I0 - 1;
  if ( I  <  I0 ) 
   then goto _270;
  for JJ:=I0 to I do
   begin
    KP1  := JJ + K - M;
    T  := T + A[(JJ-1)+(K-1)*MA]*B[KP1-1];
_260:
   end;
_270:
  I  := I + 1;
  if ( I  >  I1 ) 
   then goto _290;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    KP1  := JJ + K - M;
    T  := T + A[(JJ-1)+(K-1)*MA]*B[KP1-1] + A[(JJ+0)+(K-1)*MA]*B[KP1+0] +
    A[(JJ+1)+(K-1)*MA]*B[KP1+1] + A[(JJ+2)+(K-1)*MA]*B[KP1+2] +
    A[(JJ+3)+(K-1)*MA]*B[KP1+3];
_280:
    inc(JJ,5);
   end;
_290:
  if ( A[(M-1)+(K-1)*MA] <>  0.0e0 ) 
   then goto _310;
  if ( B[K-1] - T  <>  0.0e0 ) 
   then goto _300;
  B[K-1] := 1.0e0;
  goto _320;
_300:
  IERR  := 67;
  UTAFSI('A','S','B','2','E',IERR);
  goto _390;
_310:
  B[K-1] := (B[K-1] - T)/A[(M-1)+(K-1)*MA];
_320:
 end;

{   PEEHE CCTEM TRANS(L)*X=Y }
if ( ML  =  0 ) 
 then goto _390;
if ( NM1  <  1 ) 
 then goto _390;
for KB:=1 to NM1 do
 begin
  K  := N - KB;
  LM  := Min0(ML,N-K);
  I0  := M + 1;
  I1  := M + LM;
  I  := ((LM) Mod (5)) + M;
  if ( I  =  M ) 
   then goto _340;
  for JJ:=I0 to I do
   begin
    KP1  := JJ + K - M;
    B[K-1] := B[K-1] + A[(JJ-1)+(K-1)*MA]*B[KP1-1];
_330:
   end;
_340:
  I  := I + 1;
  if ( I  >  I1 ) 
   then goto _360;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    KP1  := JJ + K - M;
    B[K-1] := B[K-1] + A[(JJ-1)+(K-1)*MA]*B[KP1-1] + A[(JJ+0)+(K-1)*MA]*
    B[KP1+0] + A[(JJ+1)+(K-1)*MA]*B[KP1+1] + A[(JJ+3-1)+(
    K-1)*MA]*B[KP1+2] + A[(JJ+3)+(K-1)*MA]*B[KP1+3];
_350:
    inc(JJ,5);
   end;
_360:
  JJ  := NLEAD[K-1];
  if ( JJ  =  K ) 
   then goto _370;
  T  := B[JJ-1];
  B[JJ-1] := B[K-1];
  B[K-1] := T;
_370:
_380:
 end;
_390:
for J:=1 to N do
 begin
  I0  := Max0(1,J-MU-ML);
  I1  := Min0(N,J+ML);
  for I:=I0 to I1 do
   begin
    K  := I - J + M;
    Z[I-1] := A[(K-1)+(J-1)*MA];
    A[(K-1)+(J-1)*MA] := 0.0e0;
_400:
   end;
  for I:=I0 to I1 do
   begin
    A[(I-1)+(J-1)*MA] := Z[I-1];
_410:
   end;
_420:
 end;
for I:=1 to N do
 begin
  J0  := Max0(1,I-ML);
  J1  := Min0(N,I+MU+ML);
  for J:=J0 to J1 do
   begin
    K  := J - I + ML + 1;
    Z[K-1] := A[(I-1)+(J-1)*MA];
    A[(I-1)+(J-1)*MA] := 0.0e0;
_430:
   end;
  for J:=J0 to J1 do
   begin
    K  := J - I + ML + 1;
    A[(I-1)+(K-1)*MA] := Z[K-1];
_440:
   end;
_450:
 end;
_460:
end;

end.
